'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _getRouteParams = require('react-router/lib/getRouteParams');

var _getRouteParams2 = _interopRequireDefault(_getRouteParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AsyncPropsContainer = function (_Component) {
	_inherits(AsyncPropsContainer, _Component);

	function AsyncPropsContainer() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, AsyncPropsContainer);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AsyncPropsContainer.__proto__ || Object.getPrototypeOf(AsyncPropsContainer)).call.apply(_ref, [this].concat(args))), _this), _this.state = { newProps: {} }, _this.componentWillMount = function () {
			return _this.onComponentLoad(_this.props);
		}, _this.componentWillReceiveProps = function (props) {
			return _this.onComponentLoad(props);
		}, _this.onComponentLoad = function (props) {
			var Component = props.Component;
			var componentProps = props.componentProps;
			var asyncProps = props.asyncProps;
			// If there is asyncProps don't load needs as this is the initial render

			if (asyncProps) return;
			_this.loadNeeds(Component, componentProps);
		}, _this.loadNeeds = function (Component, componentProps) {
			if (!Component.needs) return;
			_this.setState({ newProps: {} });
			Promise.resolve(Component.needs(componentProps, _this.context.store)).then(function (newProps) {
				_this.setState({ newProps: newProps });
			});
		}, _this.render = function () {
			var _this$props = _this.props;
			var Component = _this$props.Component;
			var componentProps = _this$props.componentProps;
			var asyncProps = _this$props.asyncProps;

			return _react2.default.createElement(Component, _extends({}, componentProps, asyncProps, _this.state.newProps));
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return AsyncPropsContainer;
}(_react.Component);

AsyncPropsContainer.contextTypes = {
	store: _react2.default.PropTypes.object
};

var AsyncRouterContext = function (_Component2) {
	_inherits(AsyncRouterContext, _Component2);

	function AsyncRouterContext(props) {
		_classCallCheck(this, AsyncRouterContext);

		var _this2 = _possibleConstructorReturn(this, (AsyncRouterContext.__proto__ || Object.getPrototypeOf(AsyncRouterContext)).call(this, props));

		_initialiseProps.call(_this2);

		_this2.asyncProps = props.asyncProps;
		return _this2;
	}

	return AsyncRouterContext;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this3 = this;

	this.componentDidMount = function () {
		// Clear out the asyncProps, as we only want these to be used on the 
		// initial render
		_this3.asyncProps = null;
	};

	this.render = function () {
		var asyncProps = _this3.asyncProps;
		var i = _this3.props.components.length - 1;
		return _react2.default.createElement(_reactRouter.RouterContext, _extends({}, _this3.props, {
			createElement: function createElement(Component, props) {
				return _react2.default.createElement(AsyncPropsContainer, {
					Component: Component,
					componentProps: props,
					asyncProps: asyncProps != null ? asyncProps[i--] || {} : null
				});
			}
		}));
	};
};

;

exports.default = AsyncRouterContext;
module.exports = exports['default'];