"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fetchNeeds;
function fetchNeeds(params, store) {
  var _this = this;

  // Filter out undefined values, can happen if components are loaded 
  // asynchonously
  var components = params.components.filter(function (c) {
    return c;
  });
  var args = Array.prototype.slice.call(arguments);

  var needs = [];
  components.forEach(function (c) {
    return needs.push(c.needs || null);
  }, []);

  var promises = needs.map(function (need) {
    if (!need) return Promise.resolve(need);
    return need.apply(_this, args);
  });

  return Promise.all(promises);
}
module.exports = exports['default'];